#!/usr/bin/awk -f
# Copyright (C) 2015 Stavros Polymenis sp@orbitalfox.com

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.

# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

BEGIN { FS=": "; }
BEGINFILE {segment="begin"; title="Untitled"}
segment=="begin" && /^---/ { segment="meta"; next}
segment=="meta" && /^title:/ { title=$2; next}
segment=="meta" && / published:/ { published=$2; next}
segment=="meta" && / edited:/ { edited=$2; next}
segment=="meta" && /^abstract:/ { abstract=$2; next}
segment=="meta" && /^---/ {
	print "<!DOCTYPE HTML><html><head><title>"title"</title><meta http-equiv=\"Content-Type\" content=\"text/html;charset=utf-8\"><link href=\"../../style.css\" rel=\"stylesheet\" /></head><body>"
        header = "$HOME/.config/yamado/header.md"
        if( system( "[ -f " header " ] " )  != 0 ){
            header = "/usr/share/yamado/header.md"
        }
	cmd = "$YAMADODIR/converters/html/include-expanded "header
        print "<header>"
	while ( ( cmd | getline result ) > 0 ) {
		print  result
	}
        print "</header>"
	close(cmd)
	print "<h1>"title"</h1>"
	t =  length(edited) ? edited : published 
	print "<details>"
	if (length(abstract))
		print "<summary>"abstract"</summary>"
	print "<time>"t"</time></details>"
	segment="body"
	markdown="markdown"
	next
}
segment=="body" {print $0 |& markdown; }
END {
	close(markdown, "to")
	while((markdown |& getline html) > 0)
		print html
        footer = "$HOME/.config/yamado/footer.md"
        if( system( "[ -f " footer " ] " )  != 0 ){
            footer = "/usr/share/yamado/footer.md"
        }
	cmd = "$YAMADODIR/converters/html/include-expanded "footer
        print "<footer>"
	while ( ( cmd | getline result ) > 0 ) {
		print  result
	}
        close(cmd)
        print "</footer></body></html>"
}
